| Flutter Impeller |

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
impeller::compiler::Switches Class Reference

`#include <switches.h>`

## Public Member Functions
| Switches ()
| ~Switches ()
| Switches (const fml::CommandLine &command_line)
bool | AreValid (std::ostream &explain) const
std::vector< TargetPlatform > | PlatformsToCompile () const
| A vector containing at least one valid platform. More...
TargetPlatform | SelectDefaultTargetPlatform () const
SourceOptions | CreateSourceOptions (std::optional< TargetPlatform > target_platform=std::nullopt) const

## Static Public Member Functions
static void | PrintHelp (std::ostream &stream)

## Public Attributes
std::shared_ptr< fml::UniqueFD > | working_directory = nullptr
std::vector< IncludeDir > | include_directories = {}
std::filesystem::path | source_file_name
SourceType | input_type = SourceType::kUnknown
std::filesystem::path | sl_file_name
bool | iplr = false
std::string | shader_bundle = ""
std::filesystem::path | spirv_file_name
std::filesystem::path | reflection_json_name
std::filesystem::path | reflection_header_name
std::filesystem::path | reflection_cc_name
std::filesystem::path | depfile_path
std::vector< std::string > | defines = {}
bool | json_format = false
SourceLanguage | source_language = SourceLanguage::kUnknown
uint32_t | gles_language_version = 0
std::string | metal_version = ""
std::string | entry_point = ""
std::string | entry_point_prefix = ""
bool | use_half_textures = false
bool | require_framebuffer_fetch = false

## Detailed Description

Definition at line 22 of file switches.h.

## Constructor & Destructor Documentation

## ◆ Switches() [1/2]

impeller::compiler::Switches::Switches | ( |  | ) |
| default

## ◆ ~Switches()

impeller::compiler::Switches::~Switches | ( |  | ) |
| default

## ◆ Switches() [2/2]

impeller::compiler::Switches::Switches | ( | const fml::CommandLine & | command_line | ) |
| explicit

Definition at line 172 of file switches.cc.

173 : working_directory(std::make_shared<fml::UniqueFD>(fml::OpenDirectory(
174 Utf8FromPath(std::filesystem::current_path()).c_str(),
175 false, // create if necessary,
176 fml::FilePermission::kRead))),
177 source_file_name(GetOptionAsPath(command_line, "input")),
178 input_type(SourceTypeFromCommandLine(command_line)),
179 sl_file_name(GetOptionAsPath(command_line, "sl")),
180 iplr(command_line.HasOption("iplr")),
181 shader_bundle(
182 command_line.GetOptionValueWithDefault("shader-bundle", "")),
183 spirv_file_name(GetOptionAsPath(command_line, "spirv")),
184 reflection_json_name(GetOptionAsPath(command_line, "reflection-json")),
185 reflection_header_name(
186 GetOptionAsPath(command_line, "reflection-header")),
187 reflection_cc_name(GetOptionAsPath(command_line, "reflection-cc")),
188 depfile_path(GetOptionAsPath(command_line, "depfile")),
189 json_format(command_line.HasOption("json")),
190 gles_language_version(
191 stoi(command_line.GetOptionValueWithDefault("gles-language-version",
192 "0"))),
193 metal_version(
194 command_line.GetOptionValueWithDefault("metal-version", "1.2")),
195 entry_point(
196 command_line.GetOptionValueWithDefault("entry-point", "main")),
197 entry_point_prefix(
198 command_line.GetOptionValueWithDefault("entry-point-prefix", "")),
199 use_half_textures(command_line.HasOption("use-half-textures")),
200 require_framebuffer_fetch(
201 command_line.HasOption("require-framebuffer-fetch")),
202 target_platform_(TargetPlatformFromCommandLine(command_line)),
203 runtime_stages_(RuntimeStagesFromCommandLine(command_line)) {
204 auto language = ToLowerCase(
205 command_line.GetOptionValueWithDefault("source-language", "glsl"));
206
207 source_language = ToSourceLanguage(language);
208
209 if (!working_directory || !working_directory->is_valid()) {
210 return;
211 }
212
213 for (const auto& include_dir_path : command_line.GetOptionValues("include")) {
214 if (!include_dir_path.data()) {
215 continue;
216 }
217
218 // fml::OpenDirectoryReadOnly for Windows doesn't handle relative paths
219 // beginning with `../` well, so we build an absolute path.
220
221 // Get the current working directory as a utf8 encoded string.
222 // Note that the `include_dir_path` is already utf8 encoded, and so we
223 // mustn't attempt to double-convert it to utf8 lest multi-byte characters
224 // will become mangled.
225 std::filesystem::path include_dir_absolute;
226 if (std::filesystem::path(include_dir_path).is_absolute()) {
227 include_dir_absolute = std::filesystem::path(include_dir_path);
228 } else {
229 auto cwd = Utf8FromPath(std::filesystem::current_path());
230 include_dir_absolute = std::filesystem::absolute(
231 std::filesystem::path(cwd) / include_dir_path);
232 }
233
234 auto dir = std::make_shared<fml::UniqueFD>(fml::OpenDirectoryReadOnly(
235 *working_directory, include_dir_absolute.string().c_str()));
236 if (!dir || !dir->is_valid()) {
237 continue;
238 }
239
240 IncludeDir dir_entry;
241 dir_entry.name = include_dir_path;
242 dir_entry.dir = std::move(dir);
243
244 include_directories.emplace_back(std::move(dir_entry));
245 }
246
247 for (const auto& define : command_line.GetOptionValues("define")) {
248 defines.emplace_back(define);
249 }
250 }
impeller::compiler::Switches::require_framebuffer_fetch
bool require_framebuffer_fetch
Definition: switches.h:47
impeller::compiler::Switches::reflection_cc_name
std::filesystem::path reflection_cc_name
Definition: switches.h:37
impeller::compiler::Switches::entry_point_prefix
std::string entry_point_prefix
Definition: switches.h:45
impeller::compiler::Switches::sl_file_name
std::filesystem::path sl_file_name
Definition: switches.h:31
impeller::compiler::Switches::use_half_textures
bool use_half_textures
Definition: switches.h:46
impeller::compiler::Switches::source_language
SourceLanguage source_language
Definition: switches.h:41
impeller::compiler::Switches::metal_version
std::string metal_version
Definition: switches.h:43
impeller::compiler::Switches::gles_language_version
uint32_t gles_language_version
Definition: switches.h:42
impeller::compiler::Switches::entry_point
std::string entry_point
Definition: switches.h:44
impeller::compiler::Switches::shader_bundle
std::string shader_bundle
Definition: switches.h:33
impeller::compiler::Switches::defines
std::vector< std::string > defines
Definition: switches.h:39
impeller::compiler::Switches::working_directory
std::shared_ptr< fml::UniqueFD > working_directory
Definition: switches.h:24
impeller::compiler::Switches::input_type
SourceType input_type
Definition: switches.h:27
impeller::compiler::Switches::iplr
bool iplr
Definition: switches.h:32
impeller::compiler::Switches::reflection_json_name
std::filesystem::path reflection_json_name
Definition: switches.h:35
impeller::compiler::Switches::spirv_file_name
std::filesystem::path spirv_file_name
Definition: switches.h:34
impeller::compiler::Switches::json_format
bool json_format
Definition: switches.h:40
impeller::compiler::Switches::depfile_path
std::filesystem::path depfile_path
Definition: switches.h:38
impeller::compiler::Switches::include_directories
std::vector< IncludeDir > include_directories
Definition: switches.h:25
impeller::compiler::Switches::source_file_name
std::filesystem::path source_file_name
Definition: switches.h:26
impeller::compiler::Switches::reflection_header_name
std::filesystem::path reflection_header_name
Definition: switches.h:36
impeller::compiler::ToLowerCase
std::string ToLowerCase(std::string_view string)
Definition: utilities.cc:61
impeller::compiler::GetOptionAsPath
static std::filesystem::path GetOptionAsPath(const fml::CommandLine &command_line, const char *arg)
Definition: switches.cc:165
impeller::compiler::RuntimeStagesFromCommandLine
static std::vector< TargetPlatform > RuntimeStagesFromCommandLine(const fml::CommandLine &command_line)
Definition: switches.cc:141
impeller::compiler::Utf8FromPath
std::string Utf8FromPath(const std::filesystem::path &path)
Converts a native format path to a utf8 string.
Definition: utilities.cc:30
impeller::compiler::TargetPlatformFromCommandLine
static TargetPlatform TargetPlatformFromCommandLine(const fml::CommandLine &command_line)
Definition: switches.cc:123
impeller::compiler::ToSourceLanguage
SourceLanguage ToSourceLanguage(const std::string &source_language)
Definition: types.cc:52
impeller::compiler::SourceTypeFromCommandLine
static SourceType SourceTypeFromCommandLine(const fml::CommandLine &command_line)
Definition: switches.cc:152

References defines, impeller::compiler::IncludeDir::dir, include_directories, impeller::compiler::IncludeDir::name, source_language, impeller::compiler::ToLowerCase(), impeller::compiler::ToSourceLanguage(), impeller::compiler::Utf8FromPath(), and working_directory.

## Member Function Documentation

## ◆ AreValid()

bool impeller::compiler::Switches::AreValid | ( | std::ostream & | explain | ) | const

Definition at line 252 of file switches.cc.

252 {
253 // When producing a shader bundle, all flags related to single shader inputs
254 // and outputs such as `--input` and `--spirv-file-name` are ignored. Instead,
255 // input files are read from the shader bundle spec and a single flatbuffer
256 // containing all compiled shaders and reflection state is output to `--sl`.
257 const bool shader_bundle_mode = !shader_bundle.empty();
258
259 bool valid = true;
260 if (target_platform_ == TargetPlatform::kUnknown && runtime_stages_.empty() &&
261 !shader_bundle_mode) {
262 explain << "Either a target platform was not specified, or no runtime "
263 "stages were specified."
264 << std::endl;
265 valid = false;
266 }
267
268 if (source_language == SourceLanguage::kUnknown && !shader_bundle_mode) {
269 explain << "Invalid source language type." << std::endl;
270 valid = false;
271 }
272
273 if (!working_directory || !working_directory->is_valid()) {
274 explain << "Could not open the working directory: \""
275 << Utf8FromPath(std::filesystem::current_path()).c_str() << "\""
276 << std::endl;
277 valid = false;
278 }
279
280 if (source_file_name.empty() && !shader_bundle_mode) {
281 explain << "Input file name was empty." << std::endl;
282 valid = false;
283 }
284
285 if (sl_file_name.empty()) {
286 explain << "Target shading language file name was empty." << std::endl;
287 valid = false;
288 }
289
290 if (spirv_file_name.empty() && !shader_bundle_mode) {
291 explain << "Spirv file name was empty." << std::endl;
292 valid = false;
293 }
294
295 if (iplr && shader_bundle_mode) {
296 explain << "--iplr and --shader-bundle flag cannot be specified at the "
297 "same time"
298 << std::endl;
299 valid = false;
300 }
301
302 return valid;
303 }
impeller::compiler::SourceLanguage::kUnknown
@ kUnknown
impeller::compiler::TargetPlatform::kUnknown
@ kUnknown

References iplr, impeller::compiler::kUnknown, shader_bundle, sl_file_name, source_file_name, source_language, spirv_file_name, impeller::compiler::Utf8FromPath(), and working_directory.

Referenced by impeller::compiler::Main(), and impeller::compiler::testing::TEST().

## ◆ CreateSourceOptions()

SourceOptions impeller::compiler::Switches::CreateSourceOptions | ( | std::optional< TargetPlatform > | target_platform = `std::nullopt` | ) | const

Definition at line 320 of file switches.cc.

321 {
322 SourceOptions options;
323 options.target_platform =
324 target_platform.value_or(SelectDefaultTargetPlatform());
325 options.source_language = source_language;
326 if (input_type == SourceType::kUnknown) {
327 options.type = SourceTypeFromFileName(source_file_name);
328 } else {
329 options.type = input_type;
330 }
331 options.working_directory = working_directory;
332 options.file_name = source_file_name;
333 options.include_dirs = include_directories;
334 options.defines = defines;
335 options.entry_point_name =
336 entry_point_prefix +
337 EntryPointFunctionNameFromSourceName(
338 source_file_name, options.type, options.source_language, entry_point);
339 options.json_format = json_format;
340 options.gles_language_version = gles_language_version;
341 options.metal_version = metal_version;
342 options.use_half_textures = use_half_textures;
343 options.require_framebuffer_fetch = require_framebuffer_fetch;
344 return options;
345 }
impeller::compiler::Switches::SelectDefaultTargetPlatform
TargetPlatform SelectDefaultTargetPlatform() const
Definition: switches.cc:312
impeller::compiler::SourceType::kUnknown
@ kUnknown
impeller::compiler::SourceTypeFromFileName
SourceType SourceTypeFromFileName(const std::filesystem::path &file_name)
Definition: types.cc:17
impeller::compiler::EntryPointFunctionNameFromSourceName
std::string EntryPointFunctionNameFromSourceName(const std::filesystem::path &file_name, SourceType type, SourceLanguage source_language, const std::string &entry_point_name)
Definition: types.cc:101

References impeller::compiler::SourceOptions::defines, defines, entry_point, impeller::compiler::SourceOptions::entry_point_name, entry_point_prefix, impeller::compiler::EntryPointFunctionNameFromSourceName(), impeller::compiler::SourceOptions::file_name, impeller::compiler::SourceOptions::gles_language_version, gles_language_version, include_directories, impeller::compiler::SourceOptions::include_dirs, input_type, impeller::compiler::SourceOptions::json_format, json_format, impeller::compiler::kUnknown, impeller::compiler::SourceOptions::metal_version, metal_version, impeller::compiler::SourceOptions::require_framebuffer_fetch, require_framebuffer_fetch, SelectDefaultTargetPlatform(), source_file_name, impeller::compiler::SourceOptions::source_language, source_language, impeller::compiler::SourceTypeFromFileName(), impeller::compiler::SourceOptions::target_platform, impeller::compiler::SourceOptions::type, impeller::compiler::SourceOptions::use_half_textures, use_half_textures, impeller::compiler::SourceOptions::working_directory, and working_directory.

Referenced by impeller::compiler::CompileSkSL(), impeller::compiler::GenerateShaderBundle(), impeller::compiler::Main(), impeller::compiler::OutputIPLR(), and impeller::compiler::testing::TEST().

## ◆ PlatformsToCompile()

std::vector< TargetPlatform > impeller::compiler::Switches::PlatformsToCompile | ( |  | ) | const

A vector containing at least one valid platform.

Definition at line 305 of file switches.cc.

305 {
306 if (target_platform_ == TargetPlatform::kUnknown) {
307 return runtime_stages_;
308 }
309 return {target_platform_};
310 }

References impeller::compiler::kUnknown.

Referenced by impeller::compiler::OutputIPLR().

## ◆ PrintHelp()

void impeller::compiler::Switches::PrintHelp | ( | std::ostream & | stream | ) |
| static

Definition at line 42 of file switches.cc.

42 {
43 // clang-format off
44 const std::string optional_prefix = "[optional] ";
45 const std::string optional_multiple_prefix = "[optional,multiple] ";
46 // clang-format on
47
48 stream << std::endl;
49 stream << "ImpellerC is an offline shader processor and reflection engine."
50 << std::endl;
51 stream << "---------------------------------------------------------------"
52 << std::endl;
53 stream << "Expected invocation is:" << std::endl << std::endl;
54 stream << "./impellerc <One platform or multiple runtime stages> "
55 "--input=<source_file> --sl=<sl_output_file> <optional arguments>"
56 << std::endl
57 << std::endl;
58
59 stream << "Valid platforms are:" << std::endl << std::endl;
60 stream << "One of [";
61 for (const auto& platform : kKnownPlatforms) {
62 stream << " --" << platform.first;
63 }
64 stream << " ]" << std::endl << std::endl;
65
66 stream << "Valid runtime stages are:" << std::endl << std::endl;
67 stream << "At least one of [";
68 for (const auto& platform : kKnownRuntimeStages) {
69 stream << " --" << platform.first;
70 }
71 stream << " ]" << std::endl << std::endl;
72
73 stream << "Optional arguments:" << std::endl << std::endl;
74 stream << optional_prefix
75 << "--spirv=<spirv_output_file> (ignored for --shader-bundle)"
76 << std::endl;
77 stream << optional_prefix << "--input-type={";
78 for (const auto& source_type : kKnownSourceTypes) {
79 stream << source_type.first << ", ";
80 }
81 stream << "}" << std::endl;
82 stream << optional_prefix << "--source-language=glsl|hlsl (default: glsl)"
83 << std::endl;
84 stream << optional_prefix
85 << "--entry-point=<entry_point_name> (default: main; "
86 "ignored for glsl)"
87 << std::endl;
88 stream << optional_prefix
89 << "--entry-point-prefix=<entry_point_prefix> (default: empty)"
90 << std::endl;
91 stream << optional_prefix
92 << "--iplr (causes --sl file to be emitted in "
93 "iplr format)"
94 << std::endl;
95 stream << optional_prefix
96 << "--shader-bundle=<bundle_spec> (causes --sl "
97 "file to be "
98 "emitted in Flutter GPU's shader bundle format)"
99 << std::endl;
100 stream << optional_prefix << "--reflection-json=<reflection_json_file>"
101 << std::endl;
102 stream << optional_prefix << "--reflection-header=<reflection_header_file>"
103 << std::endl;
104 stream << optional_prefix << "--reflection-cc=<reflection_cc_file>"
105 << std::endl;
106 stream << optional_multiple_prefix << "--include=<include_directory>"
107 << std::endl;
108 stream << optional_multiple_prefix << "--define=<define>" << std::endl;
109 stream << optional_prefix << "--depfile=<depfile_path>" << std::endl;
110 stream << optional_prefix << "--gles-language-version=<number>" << std::endl;
111 stream << optional_prefix << "--json" << std::endl;
112 stream << optional_prefix
113 << "--use-half-textures (force openGL semantics when "
114 "targeting metal)"
115 << std::endl;
116 stream << optional_prefix << "--require-framebuffer-fetch" << std::endl;
117 }
impeller::compiler::kKnownPlatforms
static const std::map< std::string, TargetPlatform > kKnownPlatforms
Definition: switches.cc:20
impeller::compiler::kKnownRuntimeStages
static const std::map< std::string, TargetPlatform > kKnownRuntimeStages
Definition: switches.cc:28
impeller::compiler::kKnownSourceTypes
static const std::map< std::string, SourceType > kKnownSourceTypes
Definition: switches.cc:36

References impeller::compiler::kKnownPlatforms, impeller::compiler::kKnownRuntimeStages, and impeller::compiler::kKnownSourceTypes.

Referenced by impeller::compiler::Main().

## ◆ SelectDefaultTargetPlatform()

TargetPlatform impeller::compiler::Switches::SelectDefaultTargetPlatform | ( |  | ) | const

Definition at line 312 of file switches.cc.

312 {
313 if (target_platform_ == TargetPlatform::kUnknown &&
314 !runtime_stages_.empty()) {
315 return runtime_stages_.front();
316 }
317 return target_platform_;
318 }

References impeller::compiler::kUnknown.

Referenced by CreateSourceOptions(), impeller::compiler::OutputDepfile(), and impeller::compiler::OutputIPLR().

## Member Data Documentation

## ◆ defines

std::vector<std::string> impeller::compiler::Switches::defines = {}

Definition at line 39 of file switches.h.

Referenced by CreateSourceOptions(), and Switches().

## ◆ depfile_path

std::filesystem::path impeller::compiler::Switches::depfile_path

Definition at line 38 of file switches.h.

Referenced by impeller::compiler::OutputDepfile().

## ◆ entry_point

std::string impeller::compiler::Switches::entry_point = ""

Definition at line 44 of file switches.h.

Referenced by CreateSourceOptions(), and impeller::compiler::testing::TEST().

## ◆ entry_point_prefix

std::string impeller::compiler::Switches::entry_point_prefix = ""

Definition at line 45 of file switches.h.

Referenced by CreateSourceOptions(), and impeller::compiler::testing::TEST().

## ◆ gles_language_version

uint32_t impeller::compiler::Switches::gles_language_version = 0

Definition at line 42 of file switches.h.

Referenced by CreateSourceOptions().

## ◆ include_directories

std::vector<IncludeDir> impeller::compiler::Switches::include_directories = {}

Definition at line 25 of file switches.h.

Referenced by CreateSourceOptions(), Switches(), and impeller::compiler::testing::TEST().

## ◆ input_type

SourceType impeller::compiler::Switches::input_type = SourceType::kUnknown

Definition at line 27 of file switches.h.

Referenced by CreateSourceOptions().

## ◆ iplr

bool impeller::compiler::Switches::iplr = false

Definition at line 32 of file switches.h.

Referenced by AreValid(), impeller::compiler::Main(), and impeller::compiler::OutputIPLR().

## ◆ json_format

bool impeller::compiler::Switches::json_format = false

Definition at line 40 of file switches.h.

Referenced by CreateSourceOptions(), and impeller::compiler::OutputIPLR().

## ◆ metal_version

std::string impeller::compiler::Switches::metal_version = ""

Definition at line 43 of file switches.h.

Referenced by CreateSourceOptions().

## ◆ reflection_cc_name

std::filesystem::path impeller::compiler::Switches::reflection_cc_name

Definition at line 37 of file switches.h.

Referenced by impeller::compiler::OutputReflectionData().

## ◆ reflection_header_name

std::filesystem::path impeller::compiler::Switches::reflection_header_name

Definition at line 36 of file switches.h.

Referenced by impeller::compiler::CreateReflectorOptions(), and impeller::compiler::OutputReflectionData().

## ◆ reflection_json_name

std::filesystem::path impeller::compiler::Switches::reflection_json_name

Definition at line 35 of file switches.h.

Referenced by impeller::compiler::OutputReflectionData().

## ◆ require_framebuffer_fetch

bool impeller::compiler::Switches::require_framebuffer_fetch = false

Definition at line 47 of file switches.h.

Referenced by CreateSourceOptions().

## ◆ shader_bundle

std::string impeller::compiler::Switches::shader_bundle = ""

Definition at line 33 of file switches.h.

Referenced by AreValid(), impeller::compiler::GenerateShaderBundle(), impeller::compiler::Main(), and impeller::compiler::testing::TEST().

## ◆ sl_file_name

std::filesystem::path impeller::compiler::Switches::sl_file_name

The raw shader file output by the compiler. For –iplr and –shader-bundle modes, this is used as the filename for the output flatbuffer output.

Definition at line 31 of file switches.h.

Referenced by AreValid(), impeller::compiler::GenerateShaderBundle(), impeller::compiler::OutputDepfile(), impeller::compiler::OutputIPLR(), and impeller::compiler::OutputSLFile().

## ◆ source_file_name

std::filesystem::path impeller::compiler::Switches::source_file_name

Definition at line 26 of file switches.h.

Referenced by AreValid(), impeller::compiler::CreateReflectorOptions(), CreateSourceOptions(), impeller::compiler::Main(), and impeller::compiler::testing::TEST().

## ◆ source_language

SourceLanguage impeller::compiler::Switches::source_language = SourceLanguage::kUnknown

Definition at line 41 of file switches.h.

Referenced by AreValid(), CreateSourceOptions(), Switches(), and impeller::compiler::testing::TEST().

## ◆ spirv_file_name

std::filesystem::path impeller::compiler::Switches::spirv_file_name

Definition at line 34 of file switches.h.

Referenced by AreValid(), impeller::compiler::Main(), and impeller::compiler::OutputDepfile().

## ◆ use_half_textures

bool impeller::compiler::Switches::use_half_textures = false

Definition at line 46 of file switches.h.

Referenced by CreateSourceOptions().

## ◆ working_directory

std::shared_ptr<fml::UniqueFD> impeller::compiler::Switches::working_directory = nullptr

Definition at line 24 of file switches.h.

Referenced by AreValid(), CreateSourceOptions(), impeller::compiler::GenerateShaderBundle(), impeller::compiler::Main(), impeller::compiler::OutputDepfile(), impeller::compiler::OutputIPLR(), impeller::compiler::OutputReflectionData(), impeller::compiler::OutputSLFile(), and Switches().

The documentation for this class was generated from the following files:

- impeller/compiler/switches.h
- impeller/compiler/switches.cc